/* -*- Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*
 * Copyright (c) 2000 Regents of the University of New Hampshire.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the MASH Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: /opt/src/mash/repository/vint/ns-2/cell.h,v 1.0 2000/08/28 07:14 sow Exp $
 *
 * Contributed by Sowmya Manjanatha, CNRG, University of New Hampshire, August 2000 
 */

#ifndef __atm_h__
#define __atm_h__

#include <string>
#include "config.h"
#include "packet.h"
#include "general.h"

#define CELLSIZE 53
#define BYTE 8
#define EFCI 2
#define EFCI_LAST_CELL 3
#define EFCI_LAST_UNKNOWN 7
#define EFCI_FIVE 5
#define LAST_CELL 1
#define ATM_NONE 0
#define ATM_FOUR 4
#define ATM_RM 6


struct hdr_atm {
	int gfc;
	int vpi;
	int vci;
	int type;
	bool clp;
	int hec;
	string *payload;
	
	static int offset_;
	inline static int &offset() { return offset_; }
	inline static hdr_atm* access(Packet *p) {
		return (hdr_atm*) p->access(offset_);
	}
	
	Packet *packet;   /* packet before segmentation */
	
	Packet *get_packet() { return packet; } /* original packet : before segmentation */
	void set_packet(Packet *p) { packet = p;}
	char switcher_[20];
};

#endif







