/* -*- Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */

/*
 * Copyright (c) 1999 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the MASH Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: /opt/src/mash/repository/vint/ns-2/map-ds.h,v 1.0 2001/02/18 14:45:09 sow Exp $
 *
 * Contributed by Sowmya Manjanatha, Dept. of Computer Science, UNH, February 2001 
 */


#ifndef __map_ds_h__
#define __map_ds_h__

#include "atm.h"

// Types of mapping addressed
enum map_t {

	MAP_GEIB,
	MAP_ATMF,
	MAP_AYANDEH,
	MAP_NONE
	
};

class Map_DS : public Connector {

public:

	Map_DS(map_t s) : mapType(s) { }
	virtual ~Map_DS();

protected:

	int command(int argc, const char*const* argv);
	virtual void map_af(Packet *p) { }
	virtual void map_ef(Packet *p) { }
	virtual void map_be(Packet *p) { }
	map_t mapType;

};


class Map_Ayandeh : public Map_DS {
public:
	Map_Ayandeh::Map_Ayandeh() : Map_DS(MAP_AYANDEH) { }
protected:
	void map_af(Packet *);
	void map_ef(Packet *);
	void map_be(Packet *);

private:
};


class Map_Atmf : public Map_DS {
public:
	Map_Atmf::Map_Atmf() : Map_DS(MAP_ATMF) { }
protected:
	void map_af(Packet *);
	void map_ef(Packet *);
	void map_be(Packet *);

private:
};


class Map_Geib : public Map_DS {
public:
	Map_Geib::Map_Geib(); // : Map_DS(MAP_GEIB) { }
protected:
	void map_af(Packet *);
	void map_ef(Packet *);
	void map_be(Packet *);

private:
};





#endif
